local Assets=
{
	Asset("ANIM", "anim/book_robotr.zip"),
		
	Asset("IMAGE", "images/inventoryimages/book_robotr.tex"),	
    Asset("ATLAS", "images/inventoryimages/book_robotr.xml")
}

local function doeffects(inst, pos)
    SpawnPrefab("maxwell_smoke").Transform:SetPosition(pos:Get())
    SpawnPrefab("crow",7).Transform:SetPosition(pos:Get())
    SpawnPrefab("maxwell_smoke").Transform:SetPosition(pos:Get())
end

local function canread(inst)
    return (inst.components.sanity:GetMaxSanity() >= TUNING.SHADOWWAXWELL_SANITY_PENALTY)
end

local function onread(inst, reader)

    --Check sanity
    if not canread(reader) then 
        if reader.components.talker then
            reader.components.talker:Say(GetString(reader.prefab, "ANNOUNCE_NOSANITY"))
            return true
        end
    end

    --Check reagent
    if not reader.components.inventory:Has("nightmarefuel", TUNING.SHADOWWAXWELL_FUEL_COST/2) then
        if reader.components.talker then
            reader.components.talker:Say(GetString(reader.prefab, "ANNOUNCE_NOFUEL"))
            return true
        end
    end

    reader.components.inventory:ConsumeByName("nightmarefuel", TUNING.SHADOWWAXWELL_FUEL_COST/2)

    --Ok you had everything. Make the image.
    local theta = math.random() * 2 * PI
    local pt = inst:GetPosition()
    local radius = math.random(3, 6)
    local offset = FindWalkableOffset(pt, theta, radius, 12, true)
    if offset then
        local image = SpawnPrefab("reaperrobot")
        local pos = pt + offset
        image.Transform:SetPosition(pos:Get())
        doeffects(inst, pos)
        image.components.follower:SetLeader(reader)
        reader.components.health:DoDelta(-TUNING.SHADOWWAXWELL_HEALTH_COST/1.5)
        reader.components.sanity:RecalculatePenalty()
        inst.SoundEmitter:PlaySound("dontstarve/common/chesspile_ressurect")
                    inst:Remove()
        return true
    end
end


local function fn(Sim)
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    anim:SetBank("books")
    anim:SetBuild("book_robotr")
	
	anim:PlayAnimation("book_brimstone")
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/book_robotr.xml"
	-----------------------------------
	
	inst:AddComponent("inspectable")
    inst:AddComponent("book")
    inst.components.book.onread = onread



	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
		
	return inst

end

return Prefab( "common/inventory/book_robotr", fn, Assets)
