local assets=
{
	Asset("ANIM", "anim/bronzeblade.zip"),
	Asset("ANIM", "anim/swap_bronzeblade.zip"),
 Asset("ATLAS", "images/inventoryimages/bronzeblade.xml"),
 Asset("ATLAS", "images/inventoryimages/bronzeblade.xml"),
}


local function onfinished(inst)
    inst:Remove()
end



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_bronzeblade", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end


local function onattack(inst, owner, target)
end




local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("nightmaresword")
    inst.AnimState:SetBuild("bronzeblade")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetMultColour(1, 1, 1, 1)
    
    inst:AddTag("sharp")
    
	inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(30)
    inst.components.weapon.onattack = onattack

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(50)
    inst.components.finiteuses:SetUses(50)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/bronzeblade.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    
    return inst
end

return Prefab( "common/inventory/bronzeblade", fn, assets) 