local assets = 
{
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
	Asset("ANIM", "anim/player_wolfgang.zip"),
	Asset("ANIM", "anim/player_woodie.zip"),
        Asset( "SOUND", "sound/sfx.fsb" ),
    Asset("ANIM", "anim/bbrute_robotw90.zip"),
    Asset("ANIM", "anim/bbrute_robotw92.zip"),
	Asset("ANIM", "anim/swap_goldenaxe.zip"),
	Asset("ANIM", "anim/swap_goldenpickaxe.zip"),
	Asset("ANIM", "anim/swap_boomerang.zip"),
}

local prefabs = 
{
	"gears",
	"rabbit",
	"sparks"
}


local items =
{
	AXE = "swap_goldenaxe",
	PICK = "swap_goldenpickaxe",
    SWORD = "swap_boomerang",
	"gears"
}

local start_inv = 
{
        "gears",
}	

local function onhammered(inst, worker)
	
        
        
end

local function onhit(inst, worker)
        inst.components.follower:StopFollowing()
    inst.SoundEmitter:PlaySound("dontstarve/creatures/leif/taunt_VO")
	inst.AnimState:PlayAnimation("powerdown")
			inst.components.talker:Say("WHY MASTER HATE ME?!")	
	 
end


local function SetInsaneRobot(inst)
	if not inst.insanerobot then
		inst.AnimState:SetBuild("bbrute_robotw92")
    inst.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")
	inst.AnimState:PlayAnimation("staff")
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
		inst.insanerobot = true
	end
end

local function SetSaneRobot(inst)
	if inst.insanerobot or inst.insanerobot == nil then
		inst.insanerobot = false
		inst.AnimState:SetBuild("bbrute_robotw90")
	inst.AnimState:PlayAnimation("staff")
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
    inst:RemoveTag("wererobot")  
	end
	
end

local function CheckTransformState(inst)
	if not inst.components.health:IsDead() then
		if GetPlayer().components.sanity:GetPercent() > TUNING.BEARDLING_SANITY then
			SetSaneRobot(inst)
		else
			SetInsaneRobot(inst)			
		end
	end
end


local function OnWake(inst)
	CheckTransformState(inst)
	inst.checktask = inst:DoPeriodicTask(10, CheckTransformState)
end

local function ondeath(inst)
	inst.components.sanityaura.penalty = 0
	local player = GetPlayer()
	if player then
		player.components.sanity:RecalculatePenalty()
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/death")
		local pt = inst:GetPosition()
		local gears = SpawnPrefab("gears")
		gears.Transform:SetPosition(pt.x, pt.y, pt.z)
	end
end

local function EquipItem(inst, item)
	if item then
	    inst.AnimState:OverrideSymbol("swap_object", item, item)
	    inst.AnimState:Show("ARM_carry") 
	    inst.AnimState:Hide("ARM_normal")
	end
end

local function die(inst)
	inst.components.health:Kill()
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end



local function entitydeathfn(inst, data)
    if data.inst:HasTag("player") then
        inst:DoTaskInTime(math.random(), function() inst.components.health:Kill() end)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/death")
        inst.SoundEmitter:KillSound("idle")
		local pt = inst:GetPosition()
		local robin = SpawnPrefab("robin")
		robin.Transform:SetPosition(pt.x, pt.y, pt.z)
    end
end


local function ShouldAcceptItem(inst, item)
	if (item.prefab == "gears" or item.prefab == "carrot" or item.prefab == "carrot_cooked") then
        	return true
   	end
end

local function OnGetItemFromPlayer(inst, giver, item)

    	if item.prefab == "gears" then
		
        inst.components.health:DoDelta(300)
            inst.AnimState:PlayAnimation("eat")
			local pos = Vector3(inst.Transform:GetWorldPosition())
			pos.y = pos.y + 1 + math.random()*1.5
			local spark = SpawnPrefab("sparks")
			spark.Transform:SetPosition(pos:Get())
        inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say("*BZZZZ*")

    end

        if (item.prefab == "carrot" or item.prefab == "carrot_cooked") then

		
        inst.components.health:DoDelta(50)
            inst.AnimState:PlayAnimation("quick_eat")
        inst.SoundEmitter:PlaySound("dontstarve/rabbit/beardscream_short")
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say("CARROT GOOD.")
    end
end

local function OnRefuseItem(inst, item)
    local playerprefab = GetPlayer()
    if playerprefab then
	    playerprefab.components.talker:Say(GetString(playerprefab.prefab, "ACTIONFAIL_GENERIC"))
    end
end

local function OnAttack(inst)
        inst.SoundEmitter:PlaySound(inst.soundpath .. "land")
    end

local function OnAttacked(inst, data)
    --print(inst, "OnAttacked")
    local attacker = data.attacker
        if not (attacker:HasTag("player") and not attacker:HasTag("will") ) then
    inst.components.combat:SetTarget(attacker)
    inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/hurt")
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()

	inst.Transform:SetFourFaced(inst)

    MakeCharacterPhysics(inst, 75, .5)

        inst.soundpath   = "dontstarve/creatures/rook/"
        inst.effortsound = "dontstarve/creatures/rook/steam"
	anim:SetBank("wilson")
	anim:SetBuild("bbrute_robotw90")
	anim:PlayAnimation("idle")


    anim:Hide("ARM_carry")
    anim:Hide("hat")
    anim:Hide("hat_hair")


	inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier( 0.4 )
    inst.components.locomotor.pathcaps = { ignorecreep = true }
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED*0.4

	inst:AddTag("epic")
	inst:AddTag("will")
    inst:AddTag("robot")
        inst:AddTag("character")
    inst:AddTag("largecreature")
	inst:AddTag("scarytoprey")
    inst:AddTag("notraptrigger")
    inst:AddTag("companion")

    inst.CheckTransformState = CheckTransformState --used for purpleamulet

    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "torso"
    -- inst.components.combat:SetRetargetFunction(1, Retarget)
    inst.components.combat:SetKeepTargetFunction(KeepTarget)
    inst.components.combat:SetAttackPeriod(2)
    inst.components.combat:SetRange(2, 3)
    inst.components.combat:SetDefaultDamage(35)
    inst:ListenForEvent("attack", OnAttack)
    inst:ListenForEvent("attacked", OnAttacked)

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(400)
        inst.components.health.absorb = (TUNING.ARMORWOOD_ABSORPTION)
    inst.components.health.nofadeout = true
	inst.components.health:StartRegen(TUNING.CHESTER_HEALTH_REGEN_AMOUNT/4, TUNING.CHESTER_HEALTH_REGEN_PERIOD)
    inst:ListenForEvent("death", ondeath)

    inst:AddComponent("inspectable")

   inst:AddComponent("inventory")

	inst:AddComponent("thief")

    inst:AddComponent("periodicspawner")

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({"gears","gears"})
    inst.components.lootdropper:AddRandomLoot("meat",3)
    inst.components.lootdropper:AddRandomLoot("manrabbit_tail",1)
    inst.components.lootdropper.numrandomloot = 1

SetSharedLootTable( 'robot',
{
    {'gears',  1.0},
    {'gears',  1.0},
})

local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( "portal.png" )

    inst:AddComponent("sanityaura")
    inst.components.sanityaura.penalty = TUNING.SHADOWWAXWELL_SANITY_PENALTY/5

    inst.items = items
    inst.equipfn = EquipItem

    EquipItem(inst)

    inst:ListenForEvent("entity_death", function(world, data) entitydeathfn(inst, data) end, GetWorld())

    inst:ListenForEvent("attacked", OnAttacked)

    inst:ListenForEvent("attack", OnAttack)

    inst:AddComponent("follower")

        inst:AddComponent("eater")

	local brain = require"brains/bruterobotbrain"
	inst:SetBrain(brain)
	inst:SetStateGraph("SGbruterobot")

     inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(99999)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit)

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 35
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(225/255, 100/255, 102/255)
    inst.components.talker.offset = Vector3(0,-200,0)
    inst.components.talker:StopIgnoringAll()

    inst.Transform:SetScale(2.7, 2.7, 2.7)

	--inst.components.werebeast:SetOnWereFn(SetSaneRobot)
	--inst.components.werebeast:SetOnNormaleFn(SetSaneRobot)

	--inst.components.werebeast:SetOnWereFn(SetSaneRobot)
	--inst.components.werebeast:SetOnNormaleFn(SetSaneRobot)

    CheckTransformState(inst)
	inst.OnEntityWake = OnWake

	return inst
end


return Prefab("common/bruterobot", fn, assets, prefabs)