local assets=
{
	Asset("ANIM", "anim/bulletgun.zip"),
	Asset("ANIM", "anim/swap_bulletgun.zip"), 
}

local prefabs = 
{
    "bullet_projectile",
}

local function onattack_gun(inst, attacker, target)

    if target.components.combat then
        target.components.combat:SuggestTarget(attacker)
        if target.sg and target.sg.sg.states.hit then
            target.sg:GoToState("hit")
        end
    end
end

local function onfinished(inst)
    local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
    if owner then
            owner.AnimState:PlayAnimation("hit")
            owner.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
            local brokentool = SpawnPrefab("brokentool")
            brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )
    inst:Remove()
    end
end

local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end

    local onequip = function(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_object", "swap_bulletgun", "swap_boomerang")
        owner.AnimState:Show("ARM_carry") 
        owner.AnimState:Hide("ARM_normal") 
	owner.components.combat.min_attack_period = 0.9
    end

    local onunequip = function(inst, owner) 
        owner.AnimState:Hide("ARM_carry") 
        owner.AnimState:Show("ARM_normal") 
	owner.components.combat.min_attack_period = 0.4
    end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("boomerang")
    anim:SetBuild("bulletgun")
    anim:PlayAnimation("idle")
    -------   
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/bulletgun.xml"
    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    inst:AddTag("gun")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(111)
    inst.components.weapon:SetRange(20, 25)
    inst.components.weapon:SetProjectile("bullet_projectile")
    inst.components.weapon:SetOnAttack(onattack_gun)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(10)
    inst.components.finiteuses:SetUses(10)


    inst.components.finiteuses:SetOnFinished( onfinished )



    return inst
end

return Prefab( "common/inventory/bulletgun", fn, assets, prefabs)

