local assets=
{
	Asset("ANIM", "anim/armor_robot.zip"),
 Asset("IMAGE", "images/inventoryimages/firearmor.tex"),
 Asset("ATLAS", "images/inventoryimages/firearmor.xml"),
}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/charlie/attack")
end



local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "armor_robot", "swap_body")
    inst:ListenForEvent("blocked", OnBlocked, owner)
	owner.components.health.fire_damage_scale = 0.10  
   	owner.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
        end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    inst:RemoveEventCallback("blocked", OnBlocked, owner)
	owner.components.health.fire_damage_scale = 1
    	owner.AnimState:ClearBloomEffectHandle()
end

local function fn()
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("armor_ruins")
    inst.AnimState:SetBuild("armor_robot")
    inst.AnimState:PlayAnimation("anim")
    
    inst:AddTag("sanity")

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/metalarmour"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/firearmor.xml"

	inst:AddComponent("insulator")
    inst.components.insulator.insulation = TUNING.INSULATION_LARGE  

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMORRUINS, TUNING.ARMORRUINS_ABSORPTION)
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY

    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "common/inventory/firearmor", fn, assets) 