local assets=
{ 
     Asset("ANIM", "anim/firesword.zip"),
     Asset("ANIM", "anim/swap_firesword.zip"), 
     Asset("SOUND", "sound/common.fsb"),
     Asset("ATLAS", "images/inventoryimages/firesword.xml"),
     Asset("IMAGE", "images/inventoryimages/firesword.tex"),
}

local prefabs = 
{

}

local ignitechance = 0.3  

local function ignite(inst, owner, target)
    if target.components.burnable and not target.components.burnable:IsBurning() then  
            target.components.health:DoDelta(-5)
    if math.random() < ignitechance then        
            target.components.burnable:Ignite(true)
    owner.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
        end
    end
end

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
 owner.AnimState:OverrideSymbol("swap_object", "swap_firesword", "punisher")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	owner.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	owner.components.combat.min_attack_period = 0.7
    inst.fire = SpawnPrefab( "torchfire" )
    local follower = inst.fire.entity:AddFollower()
    follower:FollowSymbol( owner.GUID, "swap_object", -35, -195, 0 )
    inst.SoundEmitter:PlaySound("dontstarve/wilson/lantern_LP", "torch")
    inst.SoundEmitter:PlaySound("dontstarve/wilson/torch_swing")
end



local function onunequip(inst,owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal")
	owner.components.combat.min_attack_period = 0.4
       	inst.fire:Remove()
    inst.fire = nil
    inst.SoundEmitter:KillSound("torch")
    inst.SoundEmitter:PlaySound("dontstarve/common/fireOut") 
end


local function fn(inst)
      local inst = CreateEntity()
      local trans = inst.entity:AddTransform()
      local anim = inst.entity:AddAnimState()
      local sound = inst.entity:AddSoundEmitter()
      MakeInventoryPhysics(inst)
    
      anim:SetBank("punisher")
      anim:SetBuild("firesword")
      anim:PlayAnimation("idle")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(72)
    inst.components.weapon:SetRange(1)
    inst.components.weapon:SetOnAttack(ignite)
    inst:AddTag("sharp") 
    inst:AddTag("firesword")  


    inst:AddComponent("finiteuses")
      inst.components.finiteuses:SetMaxUses(200)
      inst.components.finiteuses:SetUses(200)
    inst.components.finiteuses:SetOnFinished( onfinished)


    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/firesword.xml"
    -----------------------------------
    
    inst:AddComponent("equippable")


    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable.walkspeedmult = 0.77
    inst.components.equippable:SetOnUnequip( onunequip )
    

    -----------------------------------
    
    inst:AddComponent("inspectable")
    
    

    
    return inst
end

return  Prefab("common/inventory/firesword", fn, assets, prefabs)