local assets=
{
	Asset("ANIM", "anim/gun_projectile.zip"),
}

local function OnHit(inst, owner, target)
    inst:Remove()
end

local function common()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("projectile")
    anim:SetBuild("gun_projectile")
    
    inst:AddTag("projectile")
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnHit)
    
    return inst
end

local function bullet()
    local inst = common()
    inst.AnimState:PlayAnimation("ice_spin_loop", true)
    inst.Transform:SetScale(0.3, 0.3, 0.3)
    inst.components.projectile:SetSpeed(120)
    return inst
end

local function shadow()
    local inst = common()
    inst.AnimState:PlayAnimation("fire_spin_loop", true)
	inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    inst.Transform:SetScale(2.7, 2.7, 2.7)
    inst.components.projectile:SetSpeed(10)
    --colour projectile
    --inst.AnimState:SetMultColour(0, 0, 0, 1)
    return inst
end

return Prefab( "common/inventory/bullet_projectile", bullet, assets), 
       Prefab("common/inventory/shadow_projectile", shadow, assets) 
