local assets =
{
    Asset("ANIM", "anim/insanepotion.zip"),
    Asset("IMAGE", "images/inventoryimages/insanepotion.tex"),
}

local function OnEaten(inst, eater)
	eater.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
				eater.components.talker:Say(GetString(eater.prefab, "ANNOUNCE_NIGHTMAREEW"))
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("spider_gland_salve")
    inst.AnimState:SetBuild("insanepotion")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/insanepotion.xml"
    
    inst:AddComponent("edible") 
		inst.components.edible.sanityvalue = -TUNING.SANITY_HUGE*5
    inst.components.edible:SetOnEatenFn(OnEaten)

    return inst
end

return Prefab( "common/inventory/insanepotion", fn, assets)
