local assets = 
{
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
	Asset("ANIM", "anim/player_wolfgang.zip"),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
    Asset("ANIM", "anim/reaper_robotw90.zip"),
    Asset("ANIM", "anim/reaper_robotw92.zip"),
	Asset("SOUND", "sound/chess.fsb"),
	Asset("ANIM", "anim/swap_goldenaxe.zip"),
	Asset("ANIM", "anim/swap_goldenpickaxe.zip"),
	Asset("ANIM", "anim/swap_boomerang.zip"),
}

local prefabs = 
{
	"gears",
	"rabbit",
	"sparks"
}


local items =
{
	AXE = "swap_goldenaxe",
	PICK = "swap_goldenpickaxe",
    SWORD = "swap_boomerang",
	"gears"
}

local start_inv = 
{
        "gears",
}	

local function OnNewTarget(inst, data)
	    inst.components.talker:Say ("DESTROY.")
    inst.SoundEmitter:PlaySound("dontstarve/creatures/knight_nightmare/voice")
    inst.SoundEmitter:PlaySound("dontstarve/birds/takeoff_crow")    
end

local function onhammered(inst, worker)
	
        
        
end

local function onhit(inst, worker)
        inst.components.follower:StopFollowing()    
    inst.SoundEmitter:PlaySound("dontstarve/birds/chirp_crow")
                inst.sg:GoToState("play_onemanband_stomp")
			inst.components.talker:Say("THAT WAS UNPLEASANT.")	
	 
end

local function ondeath(inst)
	inst.components.sanityaura.penalty = 0
	local player = GetPlayer()
	if player then
		player.components.sanity:RecalculatePenalty()
        inst.SoundEmitter:PlaySound("dontstarve/creatures/knight_nightmare/death")
		local pt = inst:GetPosition()
		local gears = SpawnPrefab("gears")
		gears.Transform:SetPosition(pt.x, pt.y, pt.z)
	end
end

local function EquipItem(inst, item)
	if item then
	    inst.AnimState:OverrideSymbol("swap_object", item, item)
	    inst.AnimState:Show("ARM_carry") 
	    inst.AnimState:Hide("ARM_normal")
	end
end

local function die(inst)
	inst.components.health:Kill()
			inst.components.talker:Say("SYSTEMS FAILING.")
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end



local function entitydeathfn(inst, data)
    if data.inst:HasTag("player") then
        inst:DoTaskInTime(math.random(), function() inst.components.health:Kill() end)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/death")
        inst.SoundEmitter:KillSound("idle")
		local pt = inst:GetPosition()
		local rabbit = SpawnPrefab("rabbit")
		rabbit.Transform:SetPosition(pt.x, pt.y, pt.z)
    end
end


local function ShouldAcceptItem(inst, item)	
	if (item.prefab == "gears" or item.prefab == "seeds") then
        	return true
    end
end

local function OnGetItemFromPlayer(inst, giver, item)

    	if item.prefab == "gears" then
		
        inst.components.health:DoDelta(145)
            inst.AnimState:PlayAnimation("eat")
			local pos = Vector3(inst.Transform:GetWorldPosition())
			pos.y = pos.y + 1 + math.random()*1.5
			local cloud = SpawnPrefab("poopcloud")
			cloud.Transform:SetPosition(pos:Get())
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/steam")
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say("REPAIRING SYSTEMS.")

    end

        if (item.prefab == "seeds") then
		
        inst.components.health:DoDelta(50)
	inst.AnimState:PlayAnimation("quick_eat")
        inst.SoundEmitter:PlaySound("dontstarve/birds/chirp_crow")
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say("DELICIOUS. THANK YOU, MASTER.")
    end
end


local function OnRefuseItem(inst, item)
    local playerprefab = GetPlayer()
    if playerprefab then
	    playerprefab.components.talker:Say(GetString(playerprefab.prefab, "ACTIONFAIL_GENERIC"))
    end
end

local function OnAttack(inst)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/knight_nightmare/attack")
    end

local function OnAttacked(inst, data)
    --print(inst, "OnAttacked")
    local attacker = data.attacker
        if not (attacker:HasTag("player") and not attacker:HasTag("will") ) then
    inst.components.combat:SetTarget(attacker)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/knight_nightare/hurt")
                inst.sg:GoToState("hit")
			inst.components.talker:Say("AUTOMATIC SPACE BENDING ACTIVATED.")
    end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()

	inst.Transform:SetFourFaced(inst)

    MakeCharacterPhysics(inst, 75, .5)

        inst.soundpath   = "dontstarve/creatures/knight_nightmare/"
        inst.effortsound = "dontstarve/creatures/knight_nightmare/steam"
	anim:SetBank("wilson")
	anim:SetBuild("reaper_robotw90")
	anim:PlayAnimation("idle_shiver_loop")


    anim:Hide("ARM_carry")
    anim:Hide("hat")
    anim:Hide("hat_hair")


	inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier( 1)
    inst.components.locomotor.pathcaps = { ignorecreep = true }
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED*1
	inst:AddTag("epic")
    inst:AddTag("robot")
        inst:AddTag("character")
    inst:AddTag("largecreature")
	inst:AddTag("scarytoprey")
    inst:AddTag("notraptrigger")
    inst:AddTag("companion")
    inst:AddTag("wil")


    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "torso"
    -- inst.components.combat:SetRetargetFunction(1, Retarget)
    inst.components.combat:SetKeepTargetFunction(KeepTarget)
    inst.components.combat:SetAttackPeriod(0.1)
    inst.components.combat:SetDefaultDamage(15)
    inst.components.combat:SetRange(1, 1)
    inst:ListenForEvent("attack", OnAttack)
    inst:ListenForEvent("attacked", OnAttacked)
        inst.components.combat.panic_thresh = TUNING.BUNNYMAN_PANIC_THRESH

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(200)
    inst.components.health.nofadeout = true
	inst.components.health:StartRegen(20, TUNING.CHESTER_HEALTH_REGEN_PERIOD*0.75)
    inst:ListenForEvent("death", ondeath)

    inst:AddComponent("inspectable")

   inst:AddComponent("inventory")

	inst:AddComponent("thief")

    inst:AddComponent("periodicspawner")

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({"gears","gears"})
    inst.components.lootdropper:AddRandomLoot("meat",3)
    inst.components.lootdropper:AddRandomLoot("manrabbit_tail",1)
    inst.components.lootdropper.numrandomloot = 1

SetSharedLootTable( 'robot',
{
    {'gears',  1.0},
    {'gears',  1.0},
})

local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( "portal.png" )

    inst:AddComponent("sanityaura")
    inst.components.sanityaura.penalty = TUNING.SHADOWWAXWELL_SANITY_PENALTY/2

    inst.items = items
    inst.equipfn = EquipItem

    EquipItem(inst)

    inst:ListenForEvent("entity_death", function(world, data) entitydeathfn(inst, data) end, GetWorld())

    inst:ListenForEvent("attacked", OnAttacked)

    inst:ListenForEvent("attack", OnAttack)

    inst:ListenForEvent("newcombattarget", OnNewTarget)

    inst:AddComponent("follower")

        inst:AddComponent("eater")

	local brain = require"brains/reaperrobotbrain"
	inst:SetBrain(brain)
	inst:SetStateGraph("SGreaperrobot")

     inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem


    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(99999)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit)

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 35
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(115/255, 95/255, 115/255)
    inst.components.talker.offset = Vector3(0,-400,0)
    inst.components.talker:StopIgnoringAll()

    inst.Transform:SetScale(1.05, 1.05, 1.05)


	return inst
end

return Prefab("common/reaperrobot", fn, assets, prefabs)