local assets =
{
    Asset("ANIM", "anim/sanitypotion.zip"),
    Asset("IMAGE", "images/inventoryimages/sanitypotion.tex"),
}

local function OnEaten(inst, eater)
	eater.SoundEmitter:PlaySound("dontstarve/creatures/bunnyman/happy")
                    SpawnPrefab("explode_small").Transform:SetPosition(inst:GetPosition():Get())
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("spider_gland_salve")
    inst.AnimState:SetBuild("sanitypotion")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/sanitypotion.xml"
    
    inst:AddComponent("edible") 
		inst.components.edible.sanityvalue = TUNING.SANITY_HUGE*1.2
    inst.components.edible:SetOnEatenFn(OnEaten)

    return inst
end

return Prefab( "common/inventory/sanitypotion", fn, assets)
