local assets=
{
    Asset("ANIM", "anim/shadowclaw.zip"),
    Asset("SOUND", "sound/tentacle.fsb"),
}

local function shouldKeepTarget(inst, target)
    return true
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddPhysics()
    inst.Physics:SetCylinder(0.25,2)
    
    inst.Transform:SetScale(0.8, 0.8, 0.8)

    inst.AnimState:SetMultColour(1,1,1,0.5)

    inst.AnimState:SetBank("shadowcreature2")
    inst.AnimState:SetBuild("shadowclaw")
    inst.AnimState:PlayAnimation("idle", true)
 	inst.entity:AddSoundEmitter()

    inst:AddTag("shadow")
    inst:AddTag("notarget")

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.TENTACLE_HEALTH)
    
    inst:AddComponent("combat")
    inst.components.combat:SetRange(2)
    inst.components.combat:SetDefaultDamage(45)
    inst.components.combat:SetAttackPeriod(TUNING.TENTACLE_ATTACK_PERIOD)
    inst.components.combat:SetKeepTargetFunction(shouldKeepTarget)
    inst.components.combat.canbeattackedfn = function() return false end
    
    MakeLargeFreezableCharacter(inst)
    
	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({})
    
    inst:SetStateGraph("SGshadowclaw")

    inst:DoTaskInTime(9, function() inst.sg:GoToState("death") end)
    inst:DoTaskInTime(10, function() inst:Remove() end)

    return inst
end

return Prefab( "cave/ruins/shadowclaw", fn, assets)