local assets=
{
	Asset("ANIM", "anim/shadowgun.zip"),
	Asset("ANIM", "anim/swap_shadowgun.zip"), 
}

local prefabs = 
{
    "shadow_projectile",
	"shadowclaw",
}

local summonchance = 0.98


local function onattack_gun(inst, attacker, target)

    if math.random() < summonchance then
        local pt = target:GetPosition()
        local st_pt =  FindWalkableOffset(pt or owner:GetPosition(), math.random()*2*PI, 2, 3)
        if st_pt then
            inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_1")
            inst.SoundEmitter:PlaySound("dontstarve/common/shadowTentacleAttack_2")            
            st_pt = st_pt + pt
            local st = SpawnPrefab("shadowclaw")
            --print(st_pt.x, st_pt.y, st_pt.z)
            st.Transform:SetPosition(st_pt.x, st_pt.y, st_pt.z)
            st.components.combat:SetTarget(target)
        end


    if target.components.combat then
        target.components.combat:SuggestTarget(attacker)
        if target.sg and target.sg.sg.states.hit then
            target.sg:GoToState("hit")
        end

    if attacker and attacker.components.sanity then
        attacker.components.sanity:DoDelta(-5)
    end

    attacker.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")

        end
    end
end

local function onfinished(inst)
    inst.SoundEmitter:PlaySound("dontstarve/common/gem_shatter")
    inst:Remove()
end

local function OnDropped(inst)
    inst.AnimState:PlayAnimation("idle")
end

    local onequip = function(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_object", "swap_shadowgun", "swap_boomerang")
        owner.AnimState:Show("ARM_carry") 
        owner.AnimState:Hide("ARM_normal")
	owner.components.combat.min_attack_period = 1.2 
    end

    local onunequip = function(inst, owner) 
        owner.AnimState:Hide("ARM_carry") 
        owner.AnimState:Show("ARM_normal") 
	owner.components.combat.min_attack_period = 0.4
    end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("boomerang")
    anim:SetBuild("shadowgun")
    anim:PlayAnimation("idle")
    -------   
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/shadowgun.xml"
    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    inst:AddTag("gun")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(45)
    inst.components.weapon:SetRange(10, 15)
    inst.components.weapon:SetProjectile("shadow_projectile")
    inst.components.weapon:SetOnAttack(onattack_gun)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(50)
    inst.components.finiteuses:SetUses(50)
    
    inst.components.finiteuses:SetOnFinished( onfinished )



    return inst
end

return Prefab( "common/inventory/shadowgun", fn, assets, prefabs)

