local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
	Asset("ANIM", "anim/player_wolfgang.zip"),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/maxwell.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/wil.zip" ),
        Asset( "ANIM", "anim/wilton.zip" ),
        Asset( "ANIM", "anim/sil.zip" ),
        Asset( "ANIM", "anim/hil.zip" ),
	Asset( "ATLAS", "images/inventoryimages/book_robotw.xml" ),
	Asset( "IMAGE", "images/inventoryimages/book_robotw.tex" ),
	Asset( "ATLAS", "images/inventoryimages/wrobotsword.xml" ),
	Asset( "IMAGE", "images/inventoryimages/wrobotsword.tex" ),
}
local prefabs = 
{
	"williamrobot",
	"book_robotw",
	"wrobotsword",
}

local start_inv = 
{
        "cane",
        "gears",
        "gears",
        "gears",
        "gears",
        "gears",
}	


local function applymightiness(inst)

	local percent = inst.components.health:GetPercent()
	
	local scale = 1

	local mighty_scale = 1
	local wimpy_scale = .9


	if inst.strength == "normal" then
		inst.AnimState:SetBuild("wil")
	elseif inst.strength == "wimpy" then
		inst.AnimState:SetBuild("hil")	
	end

end


local function onhealthchange(inst, data)

	if inst.strength == "normal" then
		if inst.components.health.current < 55 then
			
			inst.strength = "wimpy"
			inst.components.talker:Say("These injuries are not too severe...")

		end
	elseif inst.strength == "wimpy" then
		if inst.components.health.current > 80 then

			inst.strength = "normal"
			inst.components.talker:Say("I feel better")

		end
	end

	applymightiness(inst)
end
	


local function nightmare(inst)

	if inst.components.sanity:IsSane() then  
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
    inst.SoundEmitter:PlaySound("dontstarve/charlie/warn")
    inst.SoundEmitter:PlaySound("dontstarve/creatures/knight_nightmare/voice")
			inst.talksoundoverride = "dontstarve/characters/william/talk_LP"
        inst.components.health:SetMaxHealth(80)
	inst.components.combat.damagemultiplier = 0.90
	inst.components.builder.magic_bonus = 0
	inst.components.builder.science_bonus = 1
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.05)
                inst.sg:GoToState("normalform")
	inst.SoundEmitter:KillSound("nightmaresound")
inst.entity:AddLight()
	inst.Light:Enable(false)
	inst.Light:SetRadius(26)
	inst.Light:SetFalloff(.9)
	inst.Light:SetIntensity(0.7)
	inst.Light:SetColour(253/255,179/255,179/255)
    GetWorld().components.colourcubemanager:SetOverrideColourCube(nil)
	else

            inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_NIGHTMAREFORM"))
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())  
    inst.SoundEmitter:PlaySound("dontstarve/charlie/warn")
    inst.SoundEmitter:PlaySound("dontstarve/characters/william2/death_voice")
    inst.SoundEmitter:PlaySound("dontstarve/common/throne/thronemagic", "nightmaresound")
			inst.talksoundoverride = "dontstarve/characters/william2/talk_LP"
        inst.components.health:SetMaxHealth(115)
	inst.components.combat.damagemultiplier = 1.2
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.50)
	inst.components.builder.magic_bonus = 2
	inst.components.builder.science_bonus = 0
                inst.sg:GoToState("nightmareform")
inst.entity:AddLight()
	inst.Light:Enable(true)
	inst.Light:SetRadius(50)
	inst.Light:SetFalloff(.9)
	inst.Light:SetIntensity(0.4)
	inst.Light:SetColour(90/255,80/255,90/255)
    GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/night03_cc.tex")
	end
end



local fn = function(inst)

	--speech sound and map icon
	inst.soundsname = "william"
    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("william.tex")
	--Stats
	inst:AddComponent("reader")
	inst:AddTag("inventor")

        inst.components.health:SetMaxHealth(80)
	inst.components.hunger:SetMax(165)
	inst.components.sanity:SetMax(195)
	inst.components.combat.damagemultiplier = 0.90
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.9)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.9)
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.05)	
        inst.components.health.absorb = 0.1	
	inst:AddComponent("healthRegen")
	inst.components.sanity.dapperness = TUNING.DAPPERNESS_TINY
applymightiness(inst)

	inst.components.builder.science_bonus = 1
		local booktab = {str = STRINGS.TABS.BOOKS, sort=999, icon = "tab_book.tex"}
	inst.components.builder:AddRecipeTab(booktab)

	Recipe("book_robotr", {Ingredient("papyrus", 2), Ingredient("crow", 1), Ingredient("gears", 8)}, booktab, {SCIENCE = 0, MAGIC = 2, ANCIENT = 0})

	inst:ListenForEvent("goinsane", nightmare)
	inst:ListenForEvent("gosane", nightmare)

	inst:SetStateGraph("SGwilliam")

end


-- strings! Any "WOD" below would have to be replaced by the prefab name of your character.

-- First up, the character select screen lines 
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.wil = " The Inventor"
STRINGS.CHARACTER_NAMES.wil = "William J. Danninghar"
STRINGS.CHARACTER_DESCRIPTIONS.wil = "*Brains over brawn\n*Has a terrifying problem... and tappy shoes\n*Invents stuff and things"
STRINGS.CHARACTER_QUOTES.wil = "\"This land is full of unimaginable wonders! How splendid! \""
STRINGS.CHARACTERS.WIL = require "speech_william"
return MakePlayerCharacter("wil", prefabs, assets, fn , start_inv)