local assets = 
{
        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
    Asset("ANIM", "anim/player_woodie.zip"),
	Asset("ANIM", "anim/player_wolfgang.zip"),
        Asset( "SOUND", "sound/sfx.fsb" ),
    Asset("ANIM", "anim/wx90.zip"),
    Asset("ANIM", "anim/wx92.zip"),
	Asset("SOUND", "sound/chess.fsb"),
	Asset("ANIM", "anim/swap_goldenaxe.zip"),
	Asset("ANIM", "anim/swap_goldenpickaxe.zip"),
	Asset("ANIM", "anim/swap_bronzeblade.zip"),
        Asset("ANIM", "anim/ui_chest_3x2.zip"),
        Asset("ANIM", "anim/uibutlerchest.zip"),
}

local prefabs = 
{
	"gears",
	"rabbit",
	"bronzeblade",
	"sparks"
}


local items =
{
	AXE = "swap_goldenaxe",
	PICK = "swap_goldenpickaxe",
    SWORD = "swap_bronzeblade",
	"gears"
}

local function onhammered(inst, worker)
	
        
        
end

local function onhit(inst, worker)
        inst.components.follower:StopFollowing()  
    inst.SoundEmitter:PlaySound("dontstarve/rabbit/scream")
	inst.AnimState:PlayAnimation("powerup")
			inst.components.talker:Say(" ,*-,*")	
	 
end

local function GetStatus(inst)
    --print("williamrobot - GetStatus")
    if inst.components.hunger then
        if inst.components.hunger:IsStarving(inst) then
            --print("STARVING")
            return "STARVING"
        elseif inst.components.hunger:GetPercent() < .5 then
            --print("HUNGRY")
            return "HUNGRY"
        end
    end
end

local function SetInsaneRobot(inst)
	if not inst.insanerobot then
		inst.AnimState:SetBuild("wx92")
    inst.SoundEmitter:PlaySound("dontstarve/common/ghost_spawn")
	inst.AnimState:PlayAnimation("rebirth")
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
		inst.insanerobot = true
	end
end

local function SetSaneRobot(inst)
	if inst.insanerobot or inst.insanerobot == nil then
		inst.insanerobot = false
		inst.AnimState:SetBuild("wx90")
	inst.AnimState:PlayAnimation("rebirth")
                    SpawnPrefab("statue_transition").Transform:SetPosition(inst:GetPosition():Get())
                    SpawnPrefab("statue_transition_2").Transform:SetPosition(inst:GetPosition():Get())
    inst:RemoveTag("wererobot")  
	end
	
end

local function CheckTransformState(inst)
	if not inst.components.health:IsDead() then
		if GetPlayer().components.sanity:GetPercent() > TUNING.BEARDLING_SANITY then
			SetSaneRobot(inst)
		else
			SetInsaneRobot(inst)			
		end
	end
end


local function OnWake(inst)
	CheckTransformState(inst)
	inst.checktask = inst:DoPeriodicTask(10, CheckTransformState)
end

local function OnOpen(inst)
    if not inst.components.health:IsDead() then
            inst.AnimState:PlayAnimation("hit")
			inst.components.talker:Say("C/")
    end
end 

local function OnClose(inst) 
    if not inst.components.health:IsDead() then
            inst.AnimState:PlayAnimation("hungry")
			inst.components.talker:Say("CI")
    end
end 

local slotpos = {}

for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end

local function onload(inst, data)
    if data.timeleft then
        inst.lifetime = data.timeleft
        if inst.lifetime > 0 then
            resume(inst, inst.lifetime)
        else
            die(inst)
        end
    end
end

local function Unlock(inst)
        print("Mechanical Bunny Man refuses to remain with you, monster!")

        local player = GetPlayer()
        player.profile:UnlockCharacter("wilbot")
        player.profile.dirty = true
        player.profile:Save()
end

local function ondeath(inst)
	inst.components.sanityaura.penalty = 0
	local player = GetPlayer()
	if player then
		player.components.sanity:RecalculatePenalty()
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/death")
		local pt = inst:GetPosition()
		local gears = SpawnPrefab("gears")
		gears.Transform:SetPosition(pt.x, pt.y, pt.z)
	inst.components.container:DropEverything()
			inst.components.talker:Say("X_X")
	end
end

local function EquipItem(inst, item)
	if item then
	    inst.AnimState:OverrideSymbol("swap_object", item, item)
	    inst.AnimState:Show("ARM_carry") 
	    inst.AnimState:Hide("ARM_normal")
	end
end

local function die(inst)
	inst.components.health:Kill()
			inst.components.talker:Say("X_X")
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end


local function KeepTarget(isnt, target)
    return target and target:IsValid()
end



local function entitydeathfn(inst, data)
    if data.inst:HasTag("player") then
        inst:DoTaskInTime(math.random(), function() inst.components.health:Kill() end)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/death")
        inst.SoundEmitter:KillSound("idle")
		local pt = inst:GetPosition()
		local rabbit = SpawnPrefab("rabbit")
		rabbit.Transform:SetPosition(pt.x, pt.y, pt.z)
    end
end

local function OnAttacked(inst, data)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/hurt")
	inst.components.container:Close()

end
  
local function OnAttacked(inst, data)
    --print(inst, "OnAttacked")
    local attacker = data.attacker
        if data and data.attacker and not data.attacker:HasTag("player") then
    inst.components.combat:SetTarget(attacker)
    end
end


local function ShouldAcceptItem(inst, item)

	if (item.prefab == "gears" or item.prefab == "carrot" or item.prefab == "carrot_cooked") then
        	return true
   	end
end

local function OnGetItemFromPlayer(inst, giver, item)

    	if item.prefab == "gears" then
		
        inst.components.health:DoDelta(200)
            inst.AnimState:PlayAnimation("eat")
			local pos = Vector3(inst.Transform:GetWorldPosition())
			pos.y = pos.y + 1 + math.random()*1.5
			local cloud = SpawnPrefab("poopcloud")
			cloud.Transform:SetPosition(pos:Get())
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/steam")

    end

        if (item.prefab == "carrot" or item.prefab == "carrot_cooked") then
		
        inst.components.health:DoDelta(50)
	inst.AnimState:PlayAnimation("quick_eat")
        inst.SoundEmitter:PlaySound("dontstarve/rabbit/beardscream_short")
        inst.components.follower:SetLeader(giver)
			inst.components.talker:Say(" *U*")
    end
end

local function OnRefuseItem(inst, item)
    local playerprefab = GetPlayer()
    if playerprefab then
	    playerprefab.components.talker:Say(GetString(playerprefab.prefab, "ACTIONFAIL_GENERIC"))
			inst.components.talker:Say("X")
    end
end

local function OnAttack(inst)
        inst.SoundEmitter:PlaySound("dontstarve/creatures/rook/land")
			inst.components.talker:Say("D:<")
    end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    inst.entity:AddPhysics()
	inst.Transform:SetFourFaced(inst)

    MakeCharacterPhysics(inst, 75, .5)

        inst.soundpath   = "dontstarve/creatures/rook/"
        inst.effortsound = "dontstarve/creatures/rook/steam"
	anim:SetBank("wilson")
	anim:SetBuild("wx90")
	anim:PlayAnimation("idle")


    anim:Hide("ARM_carry")
    anim:Hide("hat")
    anim:Hide("hat_hair")


	inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier( 0.75 )
    inst.components.locomotor.pathcaps = { ignorecreep = true }
    inst.components.locomotor.runspeed = TUNING.WILSON_RUN_SPEED*0.8

	inst:AddTag("epic")
    inst:AddTag("robot")
        inst:AddTag("character")
    inst:AddTag("largecreature")
	inst:AddTag("fridge")
    inst:AddTag("notraptrigger")
    inst:AddTag("companion")


    inst.CheckTransformState = CheckTransformState --used for purpleamulet


    MakeMediumFreezableCharacter(inst, "face")

    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(300)
    inst.components.health.nofadeout = true
        inst.components.health.absorb = (TUNING.ARMORWOOD_ABSORPTION/4)
	inst.components.health:StartRegen(TUNING.CHESTER_HEALTH_REGEN_AMOUNT/4, TUNING.CHESTER_HEALTH_REGEN_PERIOD)
    inst:ListenForEvent("death", ondeath)

    inst:AddComponent("inspectable")

	inst:AddComponent("thief")

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({"gears","gears"})
    inst.components.lootdropper:AddRandomLoot("meat",3)
    inst.components.lootdropper:AddRandomLoot("manrabbit_tail",1)
    inst.components.lootdropper.numrandomloot = 1

SetSharedLootTable( 'robot',
{
    {'gears',  1.0},
    {'gears',  1.0},
})

local minimap = inst.entity:AddMiniMapEntity()
    minimap:SetIcon( "portal.png" )

    inst:AddComponent("sanityaura")
    inst.components.sanityaura.penalty = TUNING.SHADOWWAXWELL_SANITY_PENALTY/10

    inst.items = items
    inst.equipfn = EquipItem

    EquipItem(inst)

    inst:ListenForEvent("entity_death", function(world, data) entitydeathfn(inst, data) end, GetWorld())

    inst:ListenForEvent("attacked", OnAttacked)
        inst:ListenForEvent("death", Unlock)

    inst:ListenForEvent("attack", OnAttack)

    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(99999)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit)

    inst:AddComponent("follower")

        inst:AddComponent("eater")

	local brain = require"brains/williamrobotbrain"
	inst:SetBrain(brain)
	inst:SetStateGraph("SGwilliamrobot")

     inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem

    --("   container")
    inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    
    inst.components.container.onopenfn = OnOpen
    inst.components.container.onclosefn = OnClose
    
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "uibutlerchest"
    inst.components.container.widgetpos = Vector3(-1,-180,0)
    inst.components.container.widgetpos_controller = Vector3(-1,200,0)
    inst.components.container.side_align_tip = 160

    inst:AddComponent("combat")

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 35
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(225/255, 100/255, 102/255)
    inst.components.talker.offset = Vector3(0,-400,0)
    inst.components.talker:StopIgnoringAll()

    inst.Transform:SetScale(1.10, 1.10, 1.10)

	--inst.components.werebeast:SetOnWereFn(SetSaneRobot)
	--inst.components.werebeast:SetOnNormaleFn(SetSaneRobot)

	--inst.components.werebeast:SetOnWereFn(SetSaneRobot)
	--inst.components.werebeast:SetOnNormaleFn(SetSaneRobot)

    CheckTransformState(inst)
	inst.OnEntityWake = OnWake

	return inst
end

return Prefab("common/williamrobot", fn, assets, prefabs)