local assets=
{
	Asset("ANIM", "anim/wrobotsword.zip"),
	Asset("ANIM", "anim/srobotsword.zip"),
	Asset("ANIM", "anim/swap_wrobotsword.zip"),
	Asset("ANIM", "anim/swap_srobotsword.zip"),
 Asset("ATLAS", "images/inventoryimages/wrobotsword.xml"),
 Asset("ATLAS", "images/inventoryimages/wrobotsword.xml"),
}


local function onfinished(inst)
    inst:Remove()
end



local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_wrobotsword", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
        owner.SoundEmitter:PlaySound("dontstarve/creatures/knight/hurt") 
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end


local function onattack(inst, owner, target)
        owner.SoundEmitter:PlaySound("dontstarve/creatures/knight/attack")
end




local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("nightmaresword")
    inst.AnimState:SetBuild("wrobotsword")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetMultColour(1, 1, 1, 1)
    
    inst:AddTag("sharp")
    
	inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(24)
    inst.components.weapon.onattack = onattack

    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.MINE)
    inst.components.tool:SetAction(ACTIONS.HAMMER)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(150)
    inst.components.finiteuses:SetUses(150)
    
    inst.components.finiteuses:SetOnFinished( onfinished )
    inst.components.finiteuses:SetConsumption(ACTIONS.MINE, 1 /2)
    inst.components.finiteuses:SetConsumption(ACTIONS.HAMMER, 2/3)

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/wrobotsword.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )

    
    return inst
end

return Prefab( "common/inventory/wrobotsword", fn, assets) 